<template>
	<main v-if="validity === Validity.Invalid">
		<h1>Invalid link</h1>
		Your login link is invalid. Make sure you copied the full URL that was sent to you by email.
		<br><br>
		<router-link :to="{name: 'login'}">Request a new login link</router-link>
	</main>
	<main v-else-if="validity === Validity.Error">
		<h1>Error</h1>
		<pre>{{ error }}</pre>
		<p>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</main>
	<main v-else-if="validity === Validity.IP">
		<h1>IP address mismatch</h1>
		<p>The IP address that was used to log in differs from your current IP address. The account owner will be notified.</p>
		<p>Please log in again to continue.</p>
		<p>NOTE: You can disable this security feature in your account settings (not recommended).</p>
		<br><br>
		<router-link :to="{name: 'login'}">Request a new login link</router-link>
	</main>
	<main v-else-if="validity === Validity.Expired">
		<h1>Login link expired</h1>
		<p>This login link has expired. Please log in again to continue.</p>
		<router-link :to="{name: 'vault'}">Request a new login link</router-link>
	</main>
	<main v-else-if="validity === Validity.Limit">
		<h1>Slow down</h1>
		<p>You are sending too many authentication requests too quickly.</p>
		<p v-if="retry > 0">Please try again in {{ retry }} second(s).</p>
		<p v-else>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</main>
	<main v-else-if="validity === Validity.Email">
		<h1>Please confirm your email address</h1>
		<p>To continue, you must re-enter the email address to which this login link was sent.</p>
		<br>
		<form class="gap-no read_s login" @submit.prevent="checkToken">
			<div class="form-box pa_m">
				<label for="email" class="mini-label">Re-enter your email address</label>
				<input v-focus required autocorrect="off" name="email" id="email" ref="email" v-model="email" type="email" placeholder="your@email.com" class="input text_l pa_m">
			</div>
			<button class="button block text_l pa_s" type="submit" ref="submit">Verify &rarr;</button>
		</form>
	</main>
	<main v-else>
		<h1>Please wait</h1>
		Verifying your authentication link...
	</main>
</template>

<script lang="ts">
import { Vue, Component } from "vue-property-decorator"
import { REGEXES } from "@/types"

enum Validity {
	Init,     // initial state
	Invalid,  // malformed
	IP,       // ip changed
	Email,    // ask to provide email
	Expired,  // session is not found or expired
	Error,    // misc error
	Limit,    // hit rate limiting
}

@Component({
	data () {
		return { Validity }
	},
})
export default class Auth extends Vue {
	validity = Validity.Init
	retry = 0
	error = ""
	email = ""
	token = ""

	async created () {
		this.token = this.$route.hash.slice(1)

		if (Reflect.has(this.$route.params, "key")) {
			this.token = this.$route.params.key
		}

		if (this.token.length < 1 || (!REGEXES.UUID.test(this.token) && !REGEXES.NANO.test(this.token))) {
			this.validity = Validity.Invalid
			return
		}

		if (this.$store.getters.loginAttemptValid()) {
			this.email = this.$store.state.loginAttempt.email
			return await this.checkToken()
		}

		// else ask to provide the email again
		this.validity = Validity.Email
	}

	async checkToken () {
		const url = new URL(`${process.env.VUE_APP_API}/vault/session`)
		url.searchParams.set("email", this.email)

		const req = new Request(url.toString(), {
			method: "GET",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"X-VAULT-SESSION": this.token,
			},
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			this.validity = Validity.Error
			this.error = `Couldn't reach the API`
			console.error(err)
			return
		}
		const json = await rawResponse.json()

		switch (rawResponse.status) {
		case 200:
			this.$store.commit("checkedSession")
			this.$store.commit("session", {
				key: json.session.key,
				secret: json.session.secret, // this is sent only once, here
				identity: json.session.identity,
				expires: json.session.expires,
			})

			// this login attempt is no longer valid
			this.$store.commit("setLoginAttempt", "")

			// redirect
			if (Reflect.has(this.$route.params, "redirect"))
				this.$router.replace({name: this.$route.params.redirect})
			else if (Reflect.has(this.$route.query, "redirect"))
				this.$router.replace({name: this.$route.query.redirect as string})
			else
				this.$router.replace({name: "vault"})
			return
		case 400:
			this.validity = Validity.Error
			this.error = "Malformed request"
			return
		case 403:
			this.validity = Validity.IP
			this.error = "IP address mismatch"
			return
		case 410:
			this.validity = Validity.Expired
			return
		case 418:
			this.validity = Validity.Error
			this.error = "You Shall Not Pass!"
			return
		//case 425:
		case 429:
			this.validity = Validity.Limit
			this.retry = json.retry
			return
		case 500:
			this.validity = Validity.Error
			this.error = "Internal server error"
			return
		case 502:
			this.validity = Validity.Error
			this.error = "The API is unreachable"
			return
		default:
			this.validity = Validity.Error
			this.error = `Unknown error: ${rawResponse.status}`
			return
		}
	}
}
</script>
